package  
{
	import flash.display.Bitmap;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class Card extends MovieClip
	{
		public var id:uint;
		//public var user:*;
		public var end:Boolean = false;
		private var _back:Bitmap;
		private var _tf:TextField;
		private var bmp:Bitmap;
		
		private var _icon:Icon;
		
		/**
		 * コンストラクタ関数
		 */
		public function Card() 
		{
			visible = false;
		}
		
		public function init(icon:Icon):void 
		{
			_icon = icon;
			createForward();
			setText(_icon.userName);
			setIcon(_icon.bmp);
			createBack();
			setEvent();
		}
			
		/**
		 * マウスイベントを取得する
		 */
		public function setEvent():void
		{		
			this.buttonMode = true;
			this.addEventListener( MouseEvent.MOUSE_OVER, overHandler );
			this.addEventListener( MouseEvent.MOUSE_OUT, outHandler );
			this.addEventListener( MouseEvent.CLICK, clickHandler );
		}
		
		/**
		 * マウスイベントを取得解除する
		 */
		public function unSetEvent():void
		{
			this.buttonMode = false;
			this.removeEventListener( MouseEvent.MOUSE_OVER, overHandler );
			this.removeEventListener( MouseEvent.MOUSE_OUT, outHandler );
			this.removeEventListener( MouseEvent.CLICK, clickHandler );
		}
		
		/**
		 * カードを複製する
		 */
		public function clone():Card
		{
			var card:Card = new Card();
			card.init(_icon.clone());
			return card;
		}
		
		/**
		 * カードをひっくり返す
		 */
		public function flip():void
		{
			_back.visible = !_back.visible;
		}
		
		/**
		 * 正解時の処理
		 */
		public function win():void
		{
			alpha = 0.5;
			_tf.textColor = 0x777777;
			end = true;
		}
		
		
		
		
		/**
		 * クリック時の処理
		 */
		private function clickHandler(e:MouseEvent):void 
		{
			flip();
			unSetEvent();
			dispatchEvent(new Event("onClick"));
		}
		
		/**
		 * ロールオーバー時の処理
		 */
		private function overHandler(e:MouseEvent):void 
		{
		}
		
		/**
		 * ロールアウト時の処理
		 */
		private function outHandler(e:MouseEvent):void 
		{
		}

		
		
		/**
		 * 表面の生成
		 */
		private function createForward():void
		{
			var c:Class = getDefinitionByName("card_png") as Class;
			var foward:Bitmap = new Bitmap(new c(0, 0), "auto", true);
			addChild(foward);
		}
		
		/**
		 * 裏面の生成
		 */
		private function createBack():void
		{
			var c:Class = getDefinitionByName("card_back_png") as Class;
			_back = new Bitmap(new c(0, 0), "auto", true);
			addChild(_back);
		}
		
		/**
		 * テキストの生成
		 */
		public function setText(str:String):void
		{
			_tf = addChild(new TextField())as TextField;
			_tf.selectable = false;
			_tf.mouseEnabled = false;
			_tf.multiline = true;
			_tf.wordWrap = true;
			_tf.width = 90;
			_tf.autoSize = TextFieldAutoSize.LEFT;
			_tf.text = str;
			_tf.y = this.height / 2 + 24 -10;
			
			var format:TextFormat = new TextFormat();
			format.font = "_sans";
			format.align = TextFormatAlign.CENTER;
			_tf.setTextFormat(format);
		}
		
		/**
		 * アイコンの設置
		 * @param	_bmp
		 */
		public function setIcon(_bmp:Bitmap):void
		{
			if (!_bmp) return;
			bmp = _bmp;
			bmp.smoothing = true;
			var w:Number = bmp.width;
			bmp.scaleX = 48/w;
			bmp.scaleY = 48/w;
			bmp.x = (this.width / 2 - 24)>>0;
			bmp.y = (this.height / 2 - 24 - 10)>>0;			
			visible = true;
			addChild(bmp);
		}
		
	}

}