package  
{
	import com.facebook.graph.Facebook;
	import com.orangesuzuki.util.array.ArrayUtil;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.system.Security;
	
	/**
	 * ...
	 * @author Katsushi.Suzuki
	 */
	public class FacebookLoader extends EventDispatcher
	{
		private var _login_btn:MovieClip;
		private var _numIcon:uint = 0;
		private var _friendsDataArray:Array;
		
		private var _iconArray:Array;
		private var _loadIconNum:uint = 10;
		private var _loadedNum:uint = 0;
		
		
		public function FacebookLoader(login_btn:MovieClip) 
		{
			_login_btn = login_btn;
		}
		
		public function get iconArray():Array 
		{
			return _iconArray;
		}
		
		/**
		 * 初期化します。
		 */
		public function init(appId:String):void 
		{
			debug("Facebook APIの初期化 : ");
			_iconArray = [];
			Security.loadPolicyFile("https://fbcdn-profile-a.akamaihd.net/crossdomain.xml");
			Facebook.init(appId, iniHandler);
		}
		
		/**
		 * 初期化メソッドのコールバック関数
		 * @param	response
		 * @param	fail
		 */
		private function iniHandler(response:Object, fail:Object):void 
		{
			if (response) {
				debug("アプリの認証済みです。");
				getFriendList();
				_login_btn.visible = false;
			}
			else {
				debug("//未ログイン・未認証");
				_login_btn.visible = true;
				_login_btn.addEventListener(MouseEvent.CLICK, clickHandler);
				_login_btn.buttonMode = true;
			}
		}
		
		/**
		 * ログインボタンをクリックしたときの処理
		 * @param	e
		 */
		private function clickHandler(e:MouseEvent):void 
		{
			_login_btn.removeEventListener(MouseEvent.CLICK, clickHandler);
			logIn();
		}
		
		/**
		 * ログインします。
		 */
		private function logIn():void 
		{
			debug("ログインします。");
			
            //セッション状態の管理
            //Facebook.addJSEventListener("auth.statusChange", statusChange);
			
            //権限の設定
            var opts = {};
            //ログイン・認証ウィンドウを開く
			Facebook.login(loginHandler, opts);
        }
		
		/**
		 * ログインメソッドのコールバック関数
		 * @param	response
		 * @param	fail
		 */
        private function loginHandler(response:Object, fail:Object = null):void
		{
            //ログイン・認証ウィンドウが開いた
            if (response) {
                //ログイン・認証済み
                debug("ログイン・認証済み");
				getFriendList();
				_login_btn.visible = false;
            } else {
                //ログイン・認証失敗
                debug("//ログイン・認証失敗");
				_login_btn.visible = true;
				_login_btn.addEventListener(MouseEvent.CLICK, clickHandler);
            }
        }
			
		/**
		 * 友達一覧を取得します。
		 */
		private function getFriendList():void
		{
			debug("\n友達一覧を取得します。");
			Facebook.api("/me/friends", getFriendListHandler);
		}
		
		/**
		 * 友達一覧を取得する際のコールバック関数
		 * @param	response
		 * @param	fail
		 */
		private function getFriendListHandler(response:Object, failure:Object = null):void 
		{
            if (response) {
				_friendsDataArray = [];
				
                debug("取得成功");
                var friends:Array = response as Array;
				var num:uint = Math.min(friends.length, 100);
				num = friends.length;
                for (var i:uint = 0; i < num; i++) {
					_friendsDataArray.push(friends[i]);
                }
				
				ArrayUtil.getShuffleArray(_friendsDataArray);
				
				for (var j:int = 0; j < _loadIconNum; j++) 
				{
					var friend:Object = _friendsDataArray[j];
					var icon:Icon = new Icon();
					icon.id = friend.id;
					icon.userName = friend.name;
					icon.url = Facebook.getImageUrl(friend.id, "square");	//square, small, or large
					icon.addEventListener(Event.COMPLETE, icon_loadCompleteHandler);
					icon.load();
				}
				
				dispatchEvent(new Event("loadStart"));
                
            }else {
                //失敗
            }
		}
		
		/**
		 * アイコンをロードしたときの処理
		 * @param	e
		 */
		private function icon_loadCompleteHandler(e:Event):void 
		{
			_iconArray.push(e.target as Icon);
			if (_iconArray.length >= _loadIconNum) {
				dispatchEvent(new Event(Event.COMPLETE));
			}
		}
		
		/**
		 * デバッグ用関数
		 * @param	message
		 */
		private function debug(message:*):void
		{
			//_debug_txt.appendText(String(message)+"\n");
		}
		
        /*private function statusChange(response:Object, extendedPermissions:Object = null):void
        {
            if (response.authResponse)
            {
                debug("facebook ログイン・認証成功");				
				//友達アイコンを読み込む
				getFriendList();
            }
            else
            {
                //ログイン・認証失敗
                debug("facebook ログイン・認証失敗");
            }
        }*/
		
	}

}