﻿package {
	
	import com.facebook.graph.Facebook;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.system.Security;
	import flash.text.TextField;
	
	/**
	 * Facebookアプリとの接続をテストするクラスです。
	 * 自分のアイコンを取得します。
	 */
	public class Test3 extends MovieClip
	{
		private var _debug_txt:TextField;
		private var _login_btn:MovieClip;
		
		public function Test3() 
		{
			Security.loadPolicyFile("https://fbcdn-profile-a.akamaihd.net/crossdomain.xml");
			_debug_txt = this.debug_txt;
			_login_btn = this.login_btn;
			init();
		}
		
		/**
		 * 初期化します。
		 */
		private function init():void 
		{
			debug("Facebook APIの初期化 : ");
			Facebook.init("アプリケーションIDを入れてください", initHandler);
		}
		
		/**
		 * 初期化メソッドのコールバック関数
		 * @param	response
		 * @param	fail
		 */
		private function initHandler(response:Object, fail:Object):void
		{
			if (response) {
				debug("アプリの認証済みです。");
				debug("\nユーザーID : " + response.uid);
				debug("\nアクセストークン ： " + response.accessToken);
				
				loadIcon(response.uid);
			}
			else {
				debug("未ログインまたは未認証です。");
				_login_btn.addEventListener(MouseEvent.CLICK, clickHandler);
				_login_btn.buttonMode = true;
			}
		}
		
		/**
		 * ログインボタンをクリックしたときの処理
		 * @param	e
		 */
		private function clickHandler(e:MouseEvent):void 
		{
			_login_btn.removeEventListener(MouseEvent.CLICK, clickHandler);
			logIn();
		}
		
		/**
		 * ログインします。
		 */
		private function logIn():void 
		{
			debug("ログインします。");
			
            //権限の設定
            var opts = {};
			//opts = { scope:"user_photos" };
            //opts = { scope:"publish_stream,user_photos" };
			
            //ログイン・認証ウィンドウを開く
			Facebook.login(loginHandler, opts);
		}
		
		/**
		 * ログインメソッドのコールバック関数
		 * @param	response
		 * @param	fail
		 */
        private function loginHandler(response:Object, fail:Object = null):void
		{
            if (response) {
                //ログイン・認証済み
                debug("ログイン・認証済み");
				_login_btn.visible = false;
				
				debug("\nユーザーID : " + response.uid);
				debug("\nアクセストークン ： " + response.accessToken);
				
				loadIcon(response.uid);
            } else {
                //ログイン・認証失敗
                debug("ログイン・認証失敗");
				_login_btn.visible = true;
				_login_btn.addEventListener(MouseEvent.CLICK, clickHandler);
            }
        }
		
		/**
		 * アイコン画像を読み込んで表示します。
		 * @param	id
		 */
		private function loadIcon(id:String):void 
		{
			var url:String = Facebook.getImageUrl(id, "square");
			var icon:Icon = new Icon(url);
			icon.x = 10;
			icon.y = 40;
			addChild(icon);
		}
		
		/**
		 * デバッグ用関数
		 * @param	message
		 */
		private function debug(message:*):void
		{
			_debug_txt.appendText(String(message)+"\n");
		}
	}
}
